unit DBUn1;
{ WPTools V1.85
  CopyRight 1996 by Julian Ziersch, Mnchen
}



interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DB, DBTables, StdCtrls, ExtCtrls, WPTbar, WPRuler, WpWinCtr, WPRich,
  Wpdbrich, Mask, DBCtrls, WPRtfIO, Menus, WPDefs;    

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Notebook1: TNotebook;
    Button1: TButton;
    Button2: TButton;
    DataSource1: TDataSource;
    Table1: TTable;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    DBWPRichText1: TDBWPRichText;
    WPRuler1: TWPRuler;
    WPToolBar1: TWPToolBar;
    WPRichText1: TWPRichText;
    Panel2: TPanel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    WPRuler2: TWPRuler;
    MergeForm: TWPRtfStorage;
    Button7: TButton;
    WorkBuffer: TWPRichText;
    Table1NAME: TStringField;
    Table1STREET: TStringField;
    Table1CITY: TStringField;
    Table1COUNTRY: TStringField;
    Table1STATE: TStringField;
    Table1LETTER: TMemoField;
    Button8: TButton;
    PopupMenu1: TPopupMenu;
    InsertDemoData1: TMenuItem;
    Cancel1: TMenuItem;
    Button9: TButton;
    Label5: TLabel;
    procedure Notebook1PageChanged(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure WorkBufferGetTextToInsert(Sender: TObject; var p: PChar;
      text: PChar; LenOfAutoText: Integer; tag: Word; c: Char;
      var DoContinue: Boolean);
    procedure Button8Click(Sender: TObject);
    procedure InsertDemoData1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public
  {$IFNDEF WIN32}
    Ptextbuff  : PChar;
  {$ELSE}
    textbuff  : string;   { Delphis huge string }
  {$ENDIF}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Notebook1PageChanged(Sender: TObject);
begin
   if Notebook1.PageIndex = 0 then
       Form1.Caption :=
         'RTF Data Merge Demo [Database Page]'
      else   Form1.Caption :=
         'RTF Data Merge Demo [Merge Page]';
   DBNavigator1.Enabled := (Notebook1.PageIndex = 0);
   Button2.Enabled := (Notebook1.PageIndex = 0);
   Button1.Enabled := not (Notebook1.PageIndex = 0);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if (DataSource1.State = dsEdit) or
      (DataSource1.State = dsInsert) then Table1.Post;
  Notebook1.PageIndex := (Sender as TButton).Tag;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if Table1.Active=FALSE then
  begin
     Table1.DataBaseName :=
       ExtractFilePath(Application.Exename);
    try
     Table1.Open;
    except
     Table1.CreateTable;
     Table1.Open;
    end;
  end;
  WPRichText1.FastCopyProperties(MergeForm);
  {$IFNDEF WIN32}
   System.GetMem(ptextbuff,65002);
  {$ENDIF}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin           
  {$IFNDEF WIN32}
   System.FreeMem(ptextbuff,65002);  
  {$ENDIF}
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if (DataSource1.State = dsEdit) or
      (DataSource1.State = dsInsert) then Table1.Post;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   WPRichText1.SaveAs;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    WPRichText1.PrinterSetup;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
   WPRichText1.Print;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
    WPRichText1.FontSelect;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 try
  WPRichText1.HideInsertPoints := TRUE;
  Table1.DisableControls;
  Table1.First;
  while not Table1.EOF do
  begin
    WorkBuffer.RTFText.Assign(MergeForm.RtfText);
    WorkBuffer.FastMergeText;
    WPRichText1.FastAppendText( WorkBuffer );
    Table1.Next;
  end;
 finally
  Table1.EnableControls;
  WPRichText1.Refresh;
 end;
end;

procedure TForm1.WorkBufferGetTextToInsert(Sender: TObject; var p: PChar;
  text: PChar; LenOfAutoText: Integer; tag: Word; c: Char;
  var DoContinue: Boolean);
var
  field : TField;
  {$IFNDEF WIN32}
     s : TMemoryStream;
     Size : Longint;
  {$ENDIF}
  a     : Integer;
  empty : Boolean;
  str   : string;
begin
  str := '';
  { Determine the field  ..... }
  case tag of
     1 : str := 'NAME';
     2 : str := 'STREET';
     3 : str := 'CITY';
     4 : str := 'COUNTRY';
     5 : str := 'STATE';
     20: str := 'LETTER'; { RTF Memo ! }
  end;

  { Load the data .... }
  if (str<>'') and Table1.Active then
  begin
     field := Table1.FieldByName(str);
     if field<>nil then
     begin
        {$IFDEF WIN32}
           TextBuff := field.AsString  { + #13 } { if you need a newline } ;
           p := Pchar(TextBuff);
        {$ELSE}
           if field is TMemoField then
           begin
              try
                s := TMemoryStream.Create;
                (field as TMemoField).SaveToStream(s);
                Size := s.Size;
                if Size>65000 then Size := 65000;
                s.Position := 0;
                (ptextbuff + s.Read(ptextbuff^,size))^ := #0;
                s.Free;
              except
                s.Free;
              end;
           end else
           begin
              StrPLCopy(ptextbuff, field.AsString, 256);
           end;
           p := ptextbuff;
        {$ENDIF}
     end;
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
   WPRichText1.Clear;
   WPRichText1.Invalidate;
end;

procedure TForm1.InsertDemoData1Click(Sender: TObject);
const
  dm : string = 'abcdefg hijklmnop ABCDEFGHI JKLMNOP.?'+#13;
var
  S : array[0..10] of Char;
  i,j : Integer;
  a   : TAttr;
begin
    DBWPRichText1.Changing;
    DBWPRichText1.CPPosition := $FFFFF;
    a := DBWPRichText1.Attr;
    for j:=0 to 5 do
    begin
      for i := 0 to 9 do S[i] := dm[1+Random(Length(dm))];
      s[i]:=#0;
      a.Size  := 3 + Random(32);
      a.Color := Random(256);
      DBWPRichText1.Attr := a;
      DBWPRichText1.InputText(s);
    end;
    DBWPRichText1.Invalidate;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   NoteBook1.PageIndex := 0;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
 try
  NoteBook1.PageIndex:=0;
  Table1.First;
  while not Table1.EOF do
  begin
    Table1.Next;
  end;
 finally
 end;
end;


end.
