unit MailU;

interface        

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, DBTables, ExtCtrls, WPStatus, Wpstat2, WpWinCtr, WPRich,
  WPTbar, Buttons, WPDEFS, Tabnotbk, WPRuler, Menus, WPFinder,WpParBrd,
  Tabs, SwitchU, WPRtfIO;

type
  TForm1 = class(TForm)
    Panel2: TPanel;
    Button1: TButton;
    Bevel1: TBevel;
    FieldList: TListBox;
    Table1: TTable;
    OpenDialog1: TOpenDialog;    
    Label1: TLabel;
    WPToolBar1: TWPToolBar;
    MakeInsert: TBitBtn;
    Bevel2: TBevel;
    Next: TSpeedButton;
    Prev: TSpeedButton;
    InsDate: TBitBtn;
    MergeAll: TBitBtn;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    LoadForm1: TMenuItem;
    SaveForm1: TMenuItem;
    N1: TMenuItem;
    SaveMergedText1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    WPAltStatusBar1: TWPAltStatusBar;
    Example1: TMenuItem;
    addtablerowwith3columns1: TMenuItem;
    Table3columns1: TMenuItem;
    N6columns1: TMenuItem;
    BitBtn1: TBitBtn;
    ChangeBorder1: TMenuItem;
    InsPrior: TButton;
    InsNext: TButton;
    WPParagraphBorderDlg1: TWPParagraphBorderDlg;
    Button2: TButton;
    Panel1: TPanel;
    TabSet1: TTabSet;
    WPRuler1: TWPRuler;
    Notebook1: TNotebook;
    WPRichText1: TWPRichText;
    AllRTFText: TWPRichText;
    InsSwitch: TBitBtn;
    Backup: TWPRtfStorage;
    Bevel3: TBevel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FieldListClick(Sender: TObject);
    procedure MakeInsertClick(Sender: TObject);
    procedure PrevClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure WPRichText1GetTextToInsert(Sender: TObject; var p: PChar;
      text: PChar; LenOfAutoText: Integer; tag: Word; c: Char;
      var DoContinue: Boolean);
    procedure InsDateClick(Sender: TObject);
    procedure WPToolBar1IconSelection(Sender: TObject; var Typ: TWpSelNr;
      const str: string; const group, num, index: Integer);
    procedure FormCreate(Sender: TObject);
    procedure MergeAllClick(Sender: TObject);
    procedure LoadForm1Click(Sender: TObject);
    procedure SaveForm1Click(Sender: TObject);
    procedure SaveMergedText1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure addtablerowwith3columns1Click(Sender: TObject);
    procedure Table3columns1Click(Sender: TObject);
    procedure N6columns1Click(Sender: TObject);
    procedure WPRichText1ProtectedChange(Sender: TObject; text: string;
      Tag: Word);
    procedure BitBtn1Click(Sender: TObject);
    procedure ChangeBorder1Click(Sender: TObject);
    procedure WPRichText1HyperLinkEvent(Sender: TObject; text,
      stamp: string; LineNumber: Longint);
    procedure InsPriorClick(Sender: TObject);
    procedure InsNextClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TabSet1Click(Sender: TObject);
    procedure WPRichText1ShiftTabPressed(Sender: TObject);
    procedure AllRTFTextShiftTabPressed(Sender: TObject);
    procedure Notebook1PageChanged(Sender: TObject);
    procedure InsSwitchClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  protected
      procedure WMGetMinMaxInfo(var MSG: Tmessage); message WM_GetMinMaxInfo;
  public
    { static data to be used for mailmerging }
  {$IFNDEF WIN32}
    Ptextbuff  : PChar;
    ptextsiz : Integer;
  {$ELSE}
    textbuff  : string;   { Delphis huge string }
  {$ENDIF}
    MinWidth  : Integer;
    MinHeight : Integer;
    DidMerge  : Boolean;
    NewCol : Integer;
    NeedToRestore : Boolean;
    DontMergeMemos : Boolean;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.WMGetMinMaxInfo(var MSG: Tmessage);
Begin
  inherited;
  with PMinMaxInfo(MSG.lparam)^ do
  begin
    with ptMinTrackSize do
    begin
      X := MinWidth;
      Y := MinHeight;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MinWidth  := 350;
  MinHeight := Height;
  WPToolBar1.AddControl(Button2);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  nam : string;
begin
  if OpenDialog1.Execute then
  begin
     Table1.Active := FALSE;
     nam := OpenDialog1.FileName;
     Table1.DataBaseName :=
        ExtractFilePath(nam);
     Table1.TableName :=
        ExtractFileName(nam);
     try
        Label1.Caption := nam;
        Table1.Active := TRUE;
        Table1.GetFieldNames(FieldList.Items);
        Prev.Enabled := TRUE;
        Next.Enabled := TRUE;
        MergeAll.Enabled := TRUE;
     except
        Label1.Caption := 'cannot open';
     end;
  end;
end;

{ Switch between Viewmode and Editmode.
  The MailMerge variables (InsertPoints)
  are hidden in Viewmode.
  Note: If you save the text in Viewmode
  the InsertPoints are not saved.

  You can save the Text without the inserted
  Text when HideAutomatic = TRUE
}
procedure TForm1.Button2Click(Sender: TObject);
begin
   if NoteBook1.PageIndex<>0 then exit;
   if not WPRichText1.Readonly then
   begin
     Button2.Caption := 'Now: View Mode';
     WPRichText1.Readonly := TRUE;
     WPRichText1.HideInsertPoints := TRUE;
     WPRichText1.SetFocus;
   end else
   begin
     Button2.Caption := 'Now: Edit Mode';
     WPRichText1.Readonly := FALSE;
     WPRichText1.HideInsertPoints := FALSE;
     WPRichText1.SetFocus;
   end;
end;

procedure TForm1.FieldListClick(Sender: TObject);
begin
    MakeInsert.Enabled := (FieldList.ItemIndex>=0)
      and  not WPrichText1.Readonly and
      (FieldList.Items.Count>0);
    InsSwitch.Enabled := MakeInsert.Enabled;
end;


procedure TForm1.MakeInsertClick(Sender: TObject);
var
  i : Integer;
begin
  i := FieldList.ItemIndex;
  if (i>=0) and not WprichText1.ReadOnly
     and (Notebook1.PageIndex=0) then
  begin
     { Make an insertpoint:
       InputInsertpoint(c : Char;tag : Word;text : string);
       c = any character. for example '%'
       tag = 1..65535 will be used to distinguish between the points
       text will be merged at once
     }
     WPRichText1.InputInsertPoint('%',i+1,'['+FieldList.Items[i]+']');
     if WPRichText1.Visible then WPRichText1.SetFocus;
  end;
end;

procedure TForm1.InsDateClick(Sender: TObject);
begin
  if not WprichText1.ReadOnly and (NoteBook1.PageIndex=0) then
  begin
     WPRichText1.InputInsertPoint('*',1000,'[DATE]');
     WPRichText1.SetFocus;
  end;
end;

{ This procedure will be executed when WPRichText1.MergeText was
  called up. It has to fill in the data which should be inserted.
  You should never call any WPRichText procedure within
  the GetTextToInsert Eventhandler!
  var p: PChar;  This pointer has to be nil or should
                 point to the pchar which has to be inserted.
                 (attention: dont use local arrays)
  text: PChar;   The pointer let you know about the text
                 which follows the insertpoint. You vat all text
                 until lineend by reading this varible. It can be
                 used to do some calculation or to fill in the
                 previous data. (the lenght is then LenOfAutoText)
   LenOfAutoText: Integer;
                 If you want to use the previous data this will give
                 it to you as a string:
                 Copy(StrPas(text),1,LenOfAutoText);
   tag: Word;    The second important varaiable: The tag of the
                 insertpoint.
   c: Char;      Maybe of some use: The Character which shows
                 (colored in red) the insertpoint
   var DoContinue: Boolean
                 If you assign FALSE to DoContinue, the
                 merging will be stoped.
  }
procedure TForm1.WPRichText1GetTextToInsert(Sender: TObject; var p: PChar;
  text: PChar; LenOfAutoText: Integer; tag: Word; c: Char;
  var DoContinue: Boolean);
var
  field : TField;
  {$IFNDEF WIN32}
     s : TMemoryStream;
     Size : Longint;
  {$ENDIF}
  a     : Integer;
  empty : Boolean;
  str   : string;
begin
  if Tag=1000 then { Insert today date }
  begin
     {$IFDEF WIN32}
        TextBuff := DateToStr(Date);
        p := PChar(TextBuff);
     {$ELSE}
        if ptextbuff<>nil then FreeMem(ptextbuff,ptextsiz);
        ptextbuff := nil;
        ptextsiz := 30;
        GetMem(ptextbuff,30);
        StrPLCopy(ptextbuff,DateToStr(Date),28);
        p := ptextbuff;
     {$ENDIF}
     WPRichText1.Memo.MergeAttr.Color :=
       (WPRichText1.Memo.MergeAttr.Color and 15) or
           (NewCol and 15);
     inc(newCol);
  end
  { switch MergeCopyText on or off ------- }
  { ------ insert any other text --------- }
  else if (Tag>=2000) and (Tag<=FieldList.Items.Count*4 + 2000) and Table1.Active then
  begin
     a := tag and 3;
     tag := (tag - a - 2000) div 4;
     str := FieldList.Items.Strings[tag];
     field := Table1.FieldByName(str);
     if field<>nil then
     begin
        {$IFDEF WIN32}
           if field.AsString = '' then empty := TRUE else empty := FALSE;
        {$ELSE}
           if field is TMemoField then
           begin
              try
                s := TMemoryStream.Create;
                (field as TMemoField).SaveToStream(s);
                if s.Size>0 then empty := TRUE else empty := FALSE;
                s.Free;
              except
                s.Free;
              end;
           end else
           begin
              if field.AsString = '' then empty := TRUE else empty := FALSE;
           end;
        {$ENDIF}
       
(*      { Bit 1 : IS Empty }
        { Bit 2 : Copy ON  }
*)
        if (a and 1)<>0 then
        begin
           if empty then
           begin WPRichText1.MergeCopyText((a and 2)<>0);
                 if not NeedToRestore then NeedToRestore := (a and 2)=0;
           end;
        end else
        begin
           if not empty then
           begin WPRichText1.MergeCopyText((a and 2)<>0);
                 if not NeedToRestore then NeedToRestore := (a and 2)=0;
           end;
        end;
     end;
  end
  { ------ insert any other text --------- }
  else if (Tag>0) and (Tag<=FieldList.Items.Count) and Table1.Active then
  begin
     field := Table1.FieldByName(FieldList.Items.Strings[tag-1]);
     if field<>nil then
     begin
        {$IFDEF WIN32}
           TextBuff := field.AsString  { + #13 } { if you need a newline } ;
           p := Pchar(TextBuff);
        {$ELSE}
           if field is TMemoField then
           begin
              try
                s := TMemoryStream.Create;
                (field as TMemoField).SaveToStream(s);
                Size := s.Size;
                if ptextbuff<>nil then FreeMem(ptextbuff,ptextsiz);
                ptextbuff := nil;
                ptextsiz := Size+10;
                GetMem(ptextbuff,ptextsiz);
                s.Position := 0;
                (ptextbuff + s.Read(ptextbuff^,size))^ := #0;
                s.Free;
              except
                ptextbuff := nil;
                s.Free;
              end;
           end else
           begin
              if ptextbuff<>nil then FreeMem(ptextbuff,ptextsiz);
              ptextbuff := nil;
              GetMem(ptextbuff,256);
              StrPLCopy(ptextbuff, field.AsString, 256);
           end;
           p := ptextbuff;
        {$ENDIF}

        { Merging of RTF Memos not supported }
        if  DontMergeMemos then
        begin
          if (p<>nil) and
             (strLComp(p,'{\rtf',5)=0) then p := nil;
        end;
     end;
  end;
end;

procedure TForm1.PrevClick(Sender: TObject);
begin
  if Table1.Active then
  begin
     DontMergeMemos := TRUE;
     Table1.Prior;
     Prev.Enabled := not Table1.BOF;
     Next.Enabled := not Table1.EOF;
     MergeAll.Enabled := TRUE;
     WPRichtext1.MergeText;
     DidMerge := TRUE;
     invalidate;
     DontMergeMemos := FALSE;
  end;
end;

procedure TForm1.NextClick(Sender: TObject);
begin
  if Table1.Active then
  begin
     DontMergeMemos := TRUE;
     Table1.Next;
     Prev.Enabled := not Table1.BOF;
     Next.Enabled := not Table1.EOF;
     MergeAll.Enabled := TRUE;
     WPRichtext1.MergeText;
     DidMerge := TRUE;
     invalidate;
     DontMergeMemos := FALSE;
  end;
end;

{ please include WPDEFS to the usage }
procedure TForm1.WPToolBar1IconSelection(Sender: TObject;
  var Typ: TWpSelNr; const str: string; const group, num, index: Integer);
begin
  if typ=wptIconSel then
  begin
     if group=WPI_GR_DISK then
     begin if num=WPI_CO_NEW then
           begin
                 if Notebook1.PageIndex=0 then
                 begin
                   WPRichText1.Clear;
                   WPRichText1.CPPosition := 0;
                 end else
                 begin
                   AllRtfText.Clear;
                   AllRtfText.CPPosition := 0;
                   if Table1.Active then
                   begin Table1.First;
                         MergeAll.Enabled := TRUE;
                         Next.Enabled := TRUE;
                         Prev.Enabled := FALSE;
                   end;
                 end;
                 WPToolBar1.SelectIcon(index,group,num);
           end
           else if num= WPI_CO_EXIT then Close;
     end;
  end else
  if typ=wptIconDeSel then
  begin

  end;
end;


procedure TForm1.MergeAllClick(Sender: TObject);
var
   i : Longint;
begin
 Backup.RTFText.Assign(WPRichText1.RTFText);
 NeedToRestore := FALSE;
 try
  i := 0;
  if not Table1.Active then exit;
  AllRtfText.HideInsertPoints := TRUE;
  AllRtfText.FastCopyProperties(WPRichText1);
  if MessageBox(0,'Merge all Records in Database?' + #13 +
     'RTF-Memos can be merged, too!',
        'MailMerge',IDOK)=IDOK then
  try
    Table1.First;
    while not Table1.EOF do
    begin
     inc(i);
     WPAltStatusBar1.SetString(stStatus,IntToStr(i));
     WPRichtext1.FastMergeText;
     AllRtfText.Memo.FastAppendText(WPRichText1.Memo.FirstPar);
     if NeedToRestore then
     begin WPRichText1.RTFText.Assign(Backup.RTFText);
           NeedToRestore := FALSE;
     end;
     Table1.Next;
     end;
  finally
    { After usage of FastAppendText it is neccessary to call Refresh }
    AllRtfText.Refresh;
    { the usage of FastMergeText makes it necessary to call Refresh }
    WPRichtext1.Refresh;

    Prev.Enabled := not Table1.BOF;
    Next.Enabled := not Table1.EOF;
    DidMerge := TRUE;
  end;
 finally
   WPRichText1.RTFText.Assign(Backup.RTFText);
   invalidate;
 end;
end;

procedure TForm1.LoadForm1Click(Sender: TObject);
begin
   WPRichText1.Load;    
end;

procedure TForm1.SaveForm1Click(Sender: TObject);
var
  old : Boolean;
begin
  old :=  WPRichText1.HideInsertPoints;
  { WPRichText1.HideInsertPoints has to be FALSE. Otherwise
    the insertpoints won't be saved }
  WPRichText1.HideInsertPoints := FALSE;
  WPRichText1.SaveAs;
  WPRichText1.HideInsertPoints := old;
end;

procedure TForm1.SaveMergedText1Click(Sender: TObject);
begin
   AllRtfText.SaveAs;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.addtablerowwith3columns1Click(Sender: TObject);
var
   CWidth : array[1..5] of Integer;
const
   mult = 255 div 6;
begin
   CWidth[1] := mult;
   CWidth[2] := mult * 2;
   CWidth[3] := mult * 3;
   WPRichText1.CreateTable(1,3,@Cwidth[1],FALSE);
end;

procedure TForm1.Table3columns1Click(Sender: TObject);
var
   CWidth : array[1..5] of Integer;
const
   mult = 255 div 6;
begin
   CWidth[1] := mult;
   CWidth[2] := mult * 2;
   CWidth[3] := mult * 3;
   WPRichText1.CreateExtTable(1,3,@Cwidth[1],TRUE,104,104,2);
end;

procedure TForm1.N6columns1Click(Sender: TObject);
begin
   WPRichText1.CreateTable(1,6,nil,TRUE);
end;

{ property ProtectedProp = [ppIsInsertpoint,ppAutomatic] !
  otherwise this event will not be executed.,

  Note this part of code will only work, if the text is
  merged.    }
procedure TForm1.WPRichText1ProtectedChange(Sender: TObject; text: string;
  Tag: Word);
var
  newstr : String;
  c      : Char;
  field  : TField;
  fieldname : string;
begin
  if text='' then c:=#0 else c := text[1];
  if c = '*' then
  begin
     Application.MessageBox('Cannot change DATE','ProtectedChange - Event',0);
     exit;
  end;

  if DidMerge and Table1.Active and (Tag>0) then
  begin
     fieldname := FieldList.Items.Strings[tag-1];
     field := Table1.FieldByName(fieldname);
     if field<>nil then
     begin
       if Field is TStringField then  { Update a Datafield }
       begin
          newstr := Field.AsString;
          if InputQuery('ProtectedChange - Event',
               'Change Datafield [' + fieldname + ']: "' + text+'"',
               newstr) then
          begin
             Table1.Edit;
             Field.AsString := newStr;
             Table1.Post;
             WPRichText1.MergeTextFor('#', tag);
          end;
       end else
       begin
          Application.MessageBox('Cannot edit this Fieldtype','ProtectedChange - Event',0);
       end;
     end;
  end else Application.MessageBox('Please merge data first.','ProtectedChange - Event',0);
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  if not WprichText1.ReadOnly and (NoteBook1.PageIndex=0) then
  begin
     WPRichText1.InputText(#12+#0);
     if WPRichText1.Visible then WPRichText1.SetFocus;
  end;
end;

procedure TForm1.ChangeBorder1Click(Sender: TObject);
begin
  WPParagraphBorderDlg1.Execute;  
end;

procedure TForm1.WPRichText1HyperLinkEvent(Sender: TObject; text,
  stamp: string; LineNumber: Longint);  

begin
  ShowMessage(text);
end;

{ Search for Insertpoints in the Text }
{ uses: WPFinder }
procedure TForm1.InsPriorClick(Sender: TObject);
begin
  if  (NoteBook1.PageIndex=0) then
  with WPRichText1.Finder do
  begin
    Position :=  WPRichText1.CPPosition-1;
    WildCard := '*';
    match_attr := [wmtIsInsertPoint];
    if Prev('*') then
       WPRichText1.CPPosition := FoundPosition;
    if WPRichText1.Visible then WPRichText1.SetFocus;
  end;
end;

procedure TForm1.InsNextClick(Sender: TObject);
begin
  if  (NoteBook1.PageIndex=0) then
  with WPRichText1.Finder do
  begin
    Position :=  WPRichText1.CPPosition+1;
    WildCard := '*';
    match_attr := [wmtIsInsertPoint];
    if Next('*') then
       WPRichText1.CPPosition := FoundPosition;
    if WPRichText1.Visible then WPRichText1.SetFocus;
  end;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  {$IFNDEF WIN32}
    if ptextbuff<>nil then
       FreeMem(Pointer(ptextbuff),ptextsiz);
  {$ELSE}
    textbuff := '';
  {$ENDIF}
end;

procedure TForm1.TabSet1Click(Sender: TObject);
begin
   NoteBook1.PageIndex := TabSet1.TabIndex;
end;

procedure TForm1.WPRichText1ShiftTabPressed(Sender: TObject);
begin
     NoteBook1.PageIndex := 1;
end;

procedure TForm1.AllRTFTextShiftTabPressed(Sender: TObject);
begin
    NoteBook1.PageIndex := 0;
end;

procedure TForm1.Notebook1PageChanged(Sender: TObject);
begin
   TabSet1.TabIndex := NoteBook1.PageIndex;
end;

procedure TForm1.InsSwitchClick(Sender: TObject);
var
  i : Integer;
  a : Integer;
begin
  i := FieldList.ItemIndex;
  if (i>=0) and not WprichText1.ReadOnly
     and (Notebook1.PageIndex=0) then
  begin
     SwitchForm.FieldName.Text := FieldList.Items[i];
     if SwitchForm.ShowModal = IDOK then
     begin
        { Bit 1 : IS Empty }
        if SwitchForm.cpEmpty.Checked then a := 1
        else a := 0;
        { Bit 2 : Copy ON  }
        if SwitchForm.cpOn.Checked then a := a + 2;

        WPRichText1.InputInsertPoint('?',2000+(i*4)+a,'['+SwitchForm.Last+']');
        if WPRichText1.Visible then WPRichText1.SetFocus;
     end;
  end;
end;


procedure TForm1.FormShow(Sender: TObject);
begin
    NoteBook1.PageIndex := 0;
    WPRichText1.SetFocus;
end;

end.
