unit Childwin;

interface

uses WinTypes, WinProcs, Dialogs, SysUtils, Classes, Graphics, Forms, Controls, WPRuler,
  WpWinCtr, WPRich, WPTBar, WPStatus, Menus, wptxtdef;

type
  TMDIChild = class(TForm)  
    WPRichText1: TWPRichText;
    WPRuler1: TWPRuler;
    PopupMenu1: TPopupMenu;
    LeftTab1: TMenuItem;
    RightTab1: TMenuItem;
    DecimalTab1: TMenuItem;
    CenterTab1: TMenuItem;
    Cycle1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure WPRichText1HyperLinkEvent(Sender: TObject; text,
      stamp: string; LineNumber: Longint);
    procedure WPRichText1ProtectedChange(Sender: TObject; text: string;
      Tag: Word);
    procedure TabChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    property Memo : TWPRichText read WPRichText1; { NEW }
  end;

var
  GlobalToolBar   : TWPToolBar; {NEW}  { uses  WPTBar and WPStatus }
  GlobalStatusBar : TWPStatusBarBasic; {NEW}

implementation

{$R *.DFM}

procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TMDIChild.FormCreate(Sender: TObject);
begin
  WPRichText1.WpToolBar := GlobalToolBar; {NEW}
  WPRichText1.StatusBar := GlobalStatusBar;
end;

procedure TMDIChild.FormActivate(Sender: TObject);
begin
  Memo.SetFocus; {NEW}
end;

procedure TMDIChild.WPRichText1HyperLinkEvent(Sender: TObject; text,
  stamp: string; LineNumber: Longint);
begin
    ShowMessage('Hyperlink "'+text+'" clicked ['+stamp+']');
end;

procedure TMDIChild.WPRichText1ProtectedChange(Sender: TObject;
  text: string; Tag: Word);
begin
  ShowMessage('Invisible Text "'+text+'"');
end;

procedure TMDIChild.TabChange(Sender: TObject);
begin
    with Sender as TMenuItem do
    begin
       LeftTab1.Checked    := FALSE;
       RightTab1.Checked   := FALSE;
       CenterTab1.Checked  := FALSE;
       DecimalTab1.Checked := FALSE;
       Cycle1.Checked      := FALSE;
       case tag of
         0 : WPRuler1.NewTabKind := tkLeft;
         1 : WPRuler1.NewTabKind := tkRight;
         2 : WPRuler1.NewTabKind := tkDecimal;
         3 : WPRuler1.NewTabKind := tkCenter;
         { Cycle trough tab kinds }
         4 : WPRuler1.NewTabKind := tkAll;
       end;
       Checked := TRUE;
    end;
end;

end.
